package de.intevation.flys.client.client.utils;

import java.util.Map;

import com.google.gwt.i18n.client.NumberFormat;

import com.smartgwt.client.widgets.form.fields.FormItem;

/**
 * @author <a href="mailto:raimund.renkert@intevation.de">Raimund Renkert</a>
 */
public class DoubleValidator extends Validator {

    /**
     *
     */
    @Override
    protected boolean validate(FormItem item, Map errors) {
        boolean valid = true;

        String v = (String) item.getValue();

        NumberFormat f = NumberFormat.getDecimalFormat();

        try {
            if (v == null) {
                throw new NumberFormatException("empty");
            }

            double value = f.parse(v);

            errors.remove(item.getFieldName());
        }
        catch (NumberFormatException nfe) {
            errors.put(item.getFieldName(), MSG.wrongFormat());

            item.focusInItem();

            valid = false;
        }
        return valid;
    }


    public String toProtocolString(FormItem item, Map errors) {
        if(validate(item, errors)) {
            return item.getValue().toString().replaceAll(",", ".");
        }
        else {
            return null;
        }
    }
}

